package cc.fascinated.bat.features.namehistory;

import cc.fascinated.bat.event.EventListener;
import cc.fascinated.bat.features.namehistory.profile.user.NameHistoryProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.GuildService;
import cc.fascinated.bat.service.UserService;
import lombok.NonNull;
import net.dv8tion.jda.api.events.guild.member.update.GuildMemberUpdateNicknameEvent;
import net.dv8tion.jda.api.events.user.update.UserUpdateGlobalNameEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class NameHistoryListener implements EventListener {
    private final UserService userService;
    private final GuildService guildService;

    @Autowired
    public NameHistoryListener(@NonNull UserService userService, @NonNull GuildService guildService) {
        this.userService = userService;
        this.guildService = guildService;
    }

    @Override
    public void onUserUpdateGlobalName(@NonNull BatUser user, String oldName, String newName, @NonNull UserUpdateGlobalNameEvent event) {
        NameHistoryProfile profile = user.getNameHistoryProfile();
        profile.addName(newName);
        userService.saveUser(user);
    }

    @Override
    public void onGuildMemberUpdateNickname(@NonNull BatGuild guild, @NonNull BatUser user, String oldName, String newName,
                                            @NonNull GuildMemberUpdateNicknameEvent event) {
        cc.fascinated.bat.features.namehistory.profile.guild.NameHistoryProfile profile = guild.getNameHistoryProfile();
        profile.addName(user, newName);
        guildService.saveGuild(guild);
    }
}
